%NMAXSUP  Non-maxima suppression on a 2D array.
%   [i,j,v] = nmaxsup(I): given matrix I, returns coordinates i,j
%   of local maxima in I, and values v of I in these coordinates.

function [i,j,v] = nmaxsup(I)

r = 3;
[M N] = size(I);

X = logical(ones(size(I)));
for j = -r:r
  if j>=0
    jj = [1+j:N 1:1+j-1];
  else
    jj = [N+j+1:N 1:N+j];
  end
  for i = -r:r
    if i>=0
      ii = [1+i:M 1:1+i-1];
    else
      ii = [M+i+1:M 1:M+i];
    end
    if ~(i==0 & j==0)
      X = X & (I > I(ii,jj));
    end
  end
end

[i j] = find(X);
v = I(X(:));

return